unit principale;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, uPersonne, Generics.Collections, REST.JSON,
  FMX.StdCtrls, FMX.ListView, FMX.Controls.Presentation, FMX.ScrollBox,
  FMX.Memo, FMX.Layouts, FMX.ListBox, FMX.EditBox, FMX.NumberBox, FMX.Edit,
  FMX.MultiView;

type
  TfPrincipale = class(TForm)
    Layout1: TLayout;
    Layout2: TLayout;
    Layout3: TLayout;
    Layout4: TLayout;
    memJSON: TMemo;
    Splitter1: TSplitter;
    btnSerialiser: TButton;
    btnEffacer: TButton;
    btnCharger: TButton;
    StyleBook1: TStyleBook;
    ListBox1: TListBox;
    btnMultiView: TButton;
    MultiView1: TMultiView;
    gbPersonne: TGroupBox;
    eNom: TEdit;
    ePrenom: TEdit;
    eAge: TNumberBox;
    lblAge: TLabel;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSerialiserClick(Sender: TObject);
    procedure btnEffacerClick(Sender: TObject);
    procedure btnChargerClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure MiseAJourListBox;
    { Dclarations prives }
  public
    { Dclarations publiques }
    listePersonne : TListePersonnes;
  end;

var
  fPrincipale: TfPrincipale;

implementation
{$R *.fmx}

procedure TfPrincipale.btnChargerClick(Sender: TObject);
begin
  if fileExists('demo.json') then
  begin
    memJSON.Lines.LoadFromFile('demo.json');
    listePersonne := TJson.JsonToObject<TListePersonnes>(memJSON.Lines.Text);
    MiseAJourListBox;
  end;

end;

procedure TfPrincipale.MiseAJourListBox;
var
  unePersonne : TPersonne;
begin
  ListBox1.Clear;
  for unePersonne in listePersonne do
    ListBox1.Items.Add(unePersonne.Nom + ' ' +unePersonne.Prenom + ' ('+unePersonne.Age.ToString+')');
end;

procedure TfPrincipale.btnEffacerClick(Sender: TObject);
begin
  listePersonne.Clear;
  memJSON.Lines.Clear;
  MiseAJourListBox;
end;

procedure TfPrincipale.btnSerialiserClick(Sender: TObject);
begin
  memJSON.Lines.Clear;
  memJSON.Lines.Text := TJson.ObjectToJsonString(listePersonne);
  memJSON.Lines.SaveToFile('demo.json');
end;

procedure TfPrincipale.Button2Click(Sender: TObject);
begin
  listePersonne.Add(TPersonne.Create(eNom.Text, ePrenom.Text, Round(eAge.Value)));
  MiseAJourListBox;
end;

procedure TfPrincipale.FormCreate(Sender: TObject);
begin
  listePersonne := TListePersonnes.Create;
end;

procedure TfPrincipale.FormDestroy(Sender: TObject);
begin
  listePersonne.Free;
end;

end.
